------------------------ PART I -------------------------
------------------------ Common -------------------------
local _G=GLOBAL
local require = GLOBAL.require
local language = GetModConfigData("language")

local label = {}

if language == 1 then
	label.hunger = "饥饿"
	label.obedience = "顺从"
	label.tamed = "驯服度"
else
	label.hunger = "Hunger"
	label.obedience = "Obedience"
	label.tamed = "Tamed"
end

local SHOULD_OVERWRITE_ACTION = nil
	
local function InjectFull(comp,fn_name,fn)
	local old = comp[fn_name]
	comp[fn_name] = function(self,...)
		local res = old(self,...)
		return fn(res,self,...)
	end
end

local round2=function(num, idp)
	return _G.tonumber(string.format("%." .. (idp or 0) .. "f", num))
end

local controller = require "components/playercontroller"
InjectFull(controller,"GetLeftMouseAction",function(lmb)
	if not lmb then
		return lmb
	end
	if not(lmb.target and lmb.invobject == nil and lmb.target ~= lmb.doer) then
		SHOULD_OVERWRITE_ACTION = true
	end
	return lmb
end)

InjectFull(controller,"GetRightMouseAction",function(res)
	SHOULD_OVERWRITE_ACTION = nil
	return res
end)
InjectFull(controller,"DoAction",function(res)
	SHOULD_OVERWRITE_ACTION = nil
	return res --j
end)

local function showInfo(inst,str)
	if inst then
		if inst.components.domesticatable ~= nil and inst.components.domesticatable.domestication > 0 and inst.prefab == "beefalo" then
			if inst.components.hunger then
				local val = inst.components.hunger:GetPercent()
				--饥饿
				str = str .. "\n " .. label.hunger .. ":" .. " " .. round2(inst.components.hunger.current,0)
			end

			if inst.components.domesticatable.GetObedience ~= nil then
				local obedience = inst.components.domesticatable:GetObedience()
				--顺从
				str = str .. " / ".. label.obedience .. ":" .. " " .. round2(obedience*100,0) .. "%"
			end
			if inst.components.domesticatable.GetDomestication ~= nil then
				local domest = inst.components.domesticatable:GetDomestication()
				--驯服度
				str = str .. " / " .. label.tamed .. ":" .. " " .. round2(domest*100,0) .. "%"
			end
		end
	end
	return str
end

InjectFull(_G.BufferedAction,"GetActionString",function(str,self)
	if SHOULD_OVERWRITE_ACTION then
		str = showInfo(self.target,str)
		SHOULD_OVERWRITE_ACTION = nil
	end
	return str
end)

InjectFull(_G.EntityScript,"GetDisplayName",function(name,inst)
	name = showInfo(inst,name)
	return name
end)